@echo off

echo.
echo ********** Ultima Exodus - Remastered by Fox Cunning **********
timeout /t 1 >NUL

echo.
echo ..............
echo Applying Patch
echo ..............
echo.

reg Query "HKLM\Hardware\Description\System\CentralProcessor\0" | find /i "x86" > NUL && set OS=32BIT || set OS=64BIT

SET xd3=xdelta3.exe

IF %OS%==32BIT (
	echo 32-bit OS Detected
	SET xd3=xdelta3-i686.exe
)
IF %OS%==64BIT (
	echo 64-bit OS Detected
)

timeout /t 1 >NUL

SET oldfile="Ultima - Exodus (U) [!].nes"

IF NOT EXIST "Ultima - Exodus (U) [!].nes" (
  IF EXIST "Ultima - Exodus (U).nes" (
    SET oldfile="Ultima - Exodus (U).nes"
  ) ELSE (
	echo.
	echo ***********************
    echo *** File not found! ***
	echo ***********************
    echo Make sure either "Ultima - Exodus (U) [!].nes" or "Ultima - Exodus (U).nes"
	echo is in the same folder as this file!
	echo ...........................................................................
    @pause
    exit
  )
)

echo.

%xd3% -d -vnfs %oldfile% "Ultima - Exodus Remastered Patch.vcdiff" "Ultima - Exodus Remastered.nes"
timeout /t 1 >NUL

echo.

IF ERRORLEVEL 0 (
  IF NOT EXIST "Ultima - Exodus Remastered.nes" (
	goto :Error
  ) ELSE goto :Success
) ELSE goto :Error

:Success
  echo ***************
  echo *** Succes! ***
  echo ***************
  echo Original file's CRC32:
  crc32.exe %oldfile%
  echo 0xC1A9E6C0 Expected
  echo ***********************
  echo Patched file's CRC32:
  crc32.exe "Ultima - Exodus Remastered.nes"
  echo 0xE8EB3105 Expected

:Choice
  echo.
  SET /P c=Do you wish to use the alternative "high-readability" fonts [Y/N]?
  IF /I "%c%" EQU "Y" goto :AltFonts
  IF /I "%c%" EQU "N" goto :NewFonts
  echo.
  echo Invalid choice! Please type Y or N
  goto :Choice

:NewFonts
  echo.
  echo *** All done! ***
  goto :End

:AltFonts
  echo.
  echo ................................
  echo Applying Alternative Fonts Patch
  echo ................................
  timeout /t 1 >NUL
  ren "Ultima - Exodus Remastered.nes" temp.nes
  %xd3% -d -vnfs temp.nes "altfonts.vcdiff" "Ultima - Exodus Remastered.nes"
  del /F /Q temp.nes
  IF ERRORLEVEL 0 (
	echo.
	echo *** All done! ***
	goto :End
  ) ELSE goto :Error

:Error
  echo ***************************
  echo *** Errors encountered! ***
  echo ***************************


:End
echo.
pause
exit
